/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.modelica.uml.sysml.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.uml2.common.edit.provider.IItemQualifiedTextProvider;

import org.modelica.uml.sysml.util.SysmlAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class SysmlItemProviderAdapterFactory extends SysmlAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection supportedTypes = new ArrayList();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public SysmlItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);	
		
		supportedTypes.add(IItemQualifiedTextProvider.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.Block} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BlockItemProvider blockItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.Block}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createBlockAdapter() {
		if (blockItemProvider == null) {
			blockItemProvider = new BlockItemProvider(this);
		}

		return blockItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.BlockProperty} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BlockPropertyItemProvider blockPropertyItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.BlockProperty}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createBlockPropertyAdapter() {
		if (blockPropertyItemProvider == null) {
			blockPropertyItemProvider = new BlockPropertyItemProvider(this);
		}

		return blockPropertyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.DistributedProperty} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DistributedPropertyItemProvider distributedPropertyItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.DistributedProperty}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createDistributedPropertyAdapter() {
		if (distributedPropertyItemProvider == null) {
			distributedPropertyItemProvider = new DistributedPropertyItemProvider(this);
		}

		return distributedPropertyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ValueType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ValueTypeItemProvider valueTypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ValueType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createValueTypeAdapter() {
		if (valueTypeItemProvider == null) {
			valueTypeItemProvider = new ValueTypeItemProvider(this);
		}

		return valueTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.Unit} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UnitItemProvider unitItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.Unit}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createUnitAdapter() {
		if (unitItemProvider == null) {
			unitItemProvider = new UnitItemProvider(this);
		}

		return unitItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.Dimension} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DimensionItemProvider dimensionItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.Dimension}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createDimensionAdapter() {
		if (dimensionItemProvider == null) {
			dimensionItemProvider = new DimensionItemProvider(this);
		}

		return dimensionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.Conform} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConformItemProvider conformItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.Conform}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createConformAdapter() {
		if (conformItemProvider == null) {
			conformItemProvider = new ConformItemProvider(this);
		}

		return conformItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.Rationale} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RationaleItemProvider rationaleItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.Rationale}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createRationaleAdapter() {
		if (rationaleItemProvider == null) {
			rationaleItemProvider = new RationaleItemProvider(this);
		}

		return rationaleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.Problem} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProblemItemProvider problemItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.Problem}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createProblemAdapter() {
		if (problemItemProvider == null) {
			problemItemProvider = new ProblemItemProvider(this);
		}

		return problemItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.FlowPort} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FlowPortItemProvider flowPortItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.FlowPort}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createFlowPortAdapter() {
		if (flowPortItemProvider == null) {
			flowPortItemProvider = new FlowPortItemProvider(this);
		}

		return flowPortItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.FlowProperty} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FlowPropertyItemProvider flowPropertyItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.FlowProperty}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createFlowPropertyAdapter() {
		if (flowPropertyItemProvider == null) {
			flowPropertyItemProvider = new FlowPropertyItemProvider(this);
		}

		return flowPropertyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.FlowSpecification} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FlowSpecificationItemProvider flowSpecificationItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.FlowSpecification}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createFlowSpecificationAdapter() {
		if (flowSpecificationItemProvider == null) {
			flowSpecificationItemProvider = new FlowSpecificationItemProvider(this);
		}

		return flowSpecificationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ItemFlow} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ItemFlowItemProvider itemFlowItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ItemFlow}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createItemFlowAdapter() {
		if (itemFlowItemProvider == null) {
			itemFlowItemProvider = new ItemFlowItemProvider(this);
		}

		return itemFlowItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaTypeItemProvider modelicaTypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaTypeAdapter() {
		if (modelicaTypeItemProvider == null) {
			modelicaTypeItemProvider = new ModelicaTypeItemProvider(this);
		}

		return modelicaTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaReal} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaRealItemProvider modelicaRealItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaReal}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaRealAdapter() {
		if (modelicaRealItemProvider == null) {
			modelicaRealItemProvider = new ModelicaRealItemProvider(this);
		}

		return modelicaRealItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaInteger} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaIntegerItemProvider modelicaIntegerItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaInteger}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaIntegerAdapter() {
		if (modelicaIntegerItemProvider == null) {
			modelicaIntegerItemProvider = new ModelicaIntegerItemProvider(this);
		}

		return modelicaIntegerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaString} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaStringItemProvider modelicaStringItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaString}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaStringAdapter() {
		if (modelicaStringItemProvider == null) {
			modelicaStringItemProvider = new ModelicaStringItemProvider(this);
		}

		return modelicaStringItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaBoolean} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaBooleanItemProvider modelicaBooleanItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaBoolean}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaBooleanAdapter() {
		if (modelicaBooleanItemProvider == null) {
			modelicaBooleanItemProvider = new ModelicaBooleanItemProvider(this);
		}

		return modelicaBooleanItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaClass} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaClassItemProvider modelicaClassItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaClass}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaClassAdapter() {
		if (modelicaClassItemProvider == null) {
			modelicaClassItemProvider = new ModelicaClassItemProvider(this);
		}

		return modelicaClassItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaModel} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaModelItemProvider modelicaModelItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaModel}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaModelAdapter() {
		if (modelicaModelItemProvider == null) {
			modelicaModelItemProvider = new ModelicaModelItemProvider(this);
		}

		return modelicaModelItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaBlock} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaBlockItemProvider modelicaBlockItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaBlock}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaBlockAdapter() {
		if (modelicaBlockItemProvider == null) {
			modelicaBlockItemProvider = new ModelicaBlockItemProvider(this);
		}

		return modelicaBlockItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaConnector} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaConnectorItemProvider modelicaConnectorItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaConnector}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaConnectorAdapter() {
		if (modelicaConnectorItemProvider == null) {
			modelicaConnectorItemProvider = new ModelicaConnectorItemProvider(this);
		}

		return modelicaConnectorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaRecord} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaRecordItemProvider modelicaRecordItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaRecord}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaRecordAdapter() {
		if (modelicaRecordItemProvider == null) {
			modelicaRecordItemProvider = new ModelicaRecordItemProvider(this);
		}

		return modelicaRecordItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaFunction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaFunctionItemProvider modelicaFunctionItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaFunction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaFunctionAdapter() {
		if (modelicaFunctionItemProvider == null) {
			modelicaFunctionItemProvider = new ModelicaFunctionItemProvider(this);
		}

		return modelicaFunctionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaProperty} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaPropertyItemProvider modelicaPropertyItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaProperty}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaPropertyAdapter() {
		if (modelicaPropertyItemProvider == null) {
			modelicaPropertyItemProvider = new ModelicaPropertyItemProvider(this);
		}

		return modelicaPropertyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaConnectorProperty} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaConnectorPropertyItemProvider modelicaConnectorPropertyItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaConnectorProperty}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaConnectorPropertyAdapter() {
		if (modelicaConnectorPropertyItemProvider == null) {
			modelicaConnectorPropertyItemProvider = new ModelicaConnectorPropertyItemProvider(this);
		}

		return modelicaConnectorPropertyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaEquationProperty} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaEquationPropertyItemProvider modelicaEquationPropertyItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaEquationProperty}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaEquationPropertyAdapter() {
		if (modelicaEquationPropertyItemProvider == null) {
			modelicaEquationPropertyItemProvider = new ModelicaEquationPropertyItemProvider(this);
		}

		return modelicaEquationPropertyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaComposition} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaCompositionItemProvider modelicaCompositionItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaComposition}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaCompositionAdapter() {
		if (modelicaCompositionItemProvider == null) {
			modelicaCompositionItemProvider = new ModelicaCompositionItemProvider(this);
		}

		return modelicaCompositionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaConnection} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaConnectionItemProvider modelicaConnectionItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaConnection}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaConnectionAdapter() {
		if (modelicaConnectionItemProvider == null) {
			modelicaConnectionItemProvider = new ModelicaConnectionItemProvider(this);
		}

		return modelicaConnectionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaClassifier} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaClassifierItemProvider modelicaClassifierItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaClassifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaClassifierAdapter() {
		if (modelicaClassifierItemProvider == null) {
			modelicaClassifierItemProvider = new ModelicaClassifierItemProvider(this);
		}

		return modelicaClassifierItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.modelica.uml.sysml.ModelicaPrimitiveType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelicaPrimitiveTypeItemProvider modelicaPrimitiveTypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.modelica.uml.sysml.ModelicaPrimitiveType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter createModelicaPrimitiveTypeAdapter() {
		if (modelicaPrimitiveTypeItemProvider == null) {
			modelicaPrimitiveTypeItemProvider = new ModelicaPrimitiveTypeItemProvider(this);
		}

		return modelicaPrimitiveTypeItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (blockItemProvider != null) blockItemProvider.dispose();
		if (blockPropertyItemProvider != null) blockPropertyItemProvider.dispose();
		if (distributedPropertyItemProvider != null) distributedPropertyItemProvider.dispose();
		if (valueTypeItemProvider != null) valueTypeItemProvider.dispose();
		if (unitItemProvider != null) unitItemProvider.dispose();
		if (dimensionItemProvider != null) dimensionItemProvider.dispose();
		if (conformItemProvider != null) conformItemProvider.dispose();
		if (rationaleItemProvider != null) rationaleItemProvider.dispose();
		if (problemItemProvider != null) problemItemProvider.dispose();
		if (flowPortItemProvider != null) flowPortItemProvider.dispose();
		if (flowPropertyItemProvider != null) flowPropertyItemProvider.dispose();
		if (flowSpecificationItemProvider != null) flowSpecificationItemProvider.dispose();
		if (itemFlowItemProvider != null) itemFlowItemProvider.dispose();
		if (modelicaTypeItemProvider != null) modelicaTypeItemProvider.dispose();
		if (modelicaRealItemProvider != null) modelicaRealItemProvider.dispose();
		if (modelicaIntegerItemProvider != null) modelicaIntegerItemProvider.dispose();
		if (modelicaStringItemProvider != null) modelicaStringItemProvider.dispose();
		if (modelicaBooleanItemProvider != null) modelicaBooleanItemProvider.dispose();
		if (modelicaClassItemProvider != null) modelicaClassItemProvider.dispose();
		if (modelicaModelItemProvider != null) modelicaModelItemProvider.dispose();
		if (modelicaBlockItemProvider != null) modelicaBlockItemProvider.dispose();
		if (modelicaConnectorItemProvider != null) modelicaConnectorItemProvider.dispose();
		if (modelicaRecordItemProvider != null) modelicaRecordItemProvider.dispose();
		if (modelicaFunctionItemProvider != null) modelicaFunctionItemProvider.dispose();
		if (modelicaPropertyItemProvider != null) modelicaPropertyItemProvider.dispose();
		if (modelicaConnectorPropertyItemProvider != null) modelicaConnectorPropertyItemProvider.dispose();
		if (modelicaEquationPropertyItemProvider != null) modelicaEquationPropertyItemProvider.dispose();
		if (modelicaCompositionItemProvider != null) modelicaCompositionItemProvider.dispose();
		if (modelicaConnectionItemProvider != null) modelicaConnectionItemProvider.dispose();
		if (modelicaClassifierItemProvider != null) modelicaClassifierItemProvider.dispose();
		if (modelicaPrimitiveTypeItemProvider != null) modelicaPrimitiveTypeItemProvider.dispose();
	}

}
